﻿using System;
using CoreGraphics;
using Foundation;
using Syncfusion.SfCalendar.iOS;
using UIKit;

namespace CalendariOSTest
{
	public partial class ViewController : UIViewController
	{
		
		protected ViewController(IntPtr handle) : base(handle)
		{
			// Note: this .ctor should not contain any initialization logic.
		}

		public override void ViewDidLoad()
		{
			
			base.ViewDidLoad();
			SFCalendar cal = new SFCalendar();
			cal.Appointments = getEnglishAppointments();
			cal.EnableInLine = true;
			cal.Delegate = new CalendarDelegate();
			View.AddSubview(cal);
			// Perform any additional setup after loading the view, typically from a nib.
		}

		NSMutableArray getEnglishAppointments()
		{
			NSDate today = new NSDate();
			NSMutableArray appCollection = new NSMutableArray();
			NSCalendar calendar = NSCalendar.CurrentCalendar;
			// Get the year, month, day from the date
			NSDateComponents components = calendar.Components(
				NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);
			// Set the hour, minute, second
			components.Hour = 10;
			components.Minute = 0;
			components.Second = 0;

			// Get the year, month, day from the date
			NSDateComponents endDateComponents = calendar.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);
			// Set the hour, minute, second
			endDateComponents.Hour = 12;
			endDateComponents.Minute = 0;
			endDateComponents.Second = 0;
			NSDate startDate1 = calendar.DateFromComponents(components);
			NSDate endDate1 = calendar.DateFromComponents(endDateComponents);
			SFAppointment appointment1 = new SFAppointment();
			appointment1.StartTime = startDate1;
			appointment1.EndTime = endDate1;
			components.Day = components.Day;
			endDateComponents.Day = endDateComponents.Day;
			appointment1.Subject = (NSString)"Going to park";
			appCollection.Add(appointment1);
			SFAppointment appointment12 = new SFAppointment();
			appointment12.StartTime = startDate1;
			appointment12.EndTime = endDate1;
			components.Day = components.Day;
			endDateComponents.Day = endDateComponents.Day;
			appointment12.Subject = (NSString)"Going to park";
			appCollection.Add(appointment12);
			Random randomNumber = new Random();

			for (int i = 0; i < 10; i++)
			{
				components.Hour = randomNumber.Next(10, 16);
				endDateComponents.Hour = components.Hour + randomNumber.Next(1, 3);
				NSDate startDate = calendar.DateFromComponents(components);
				NSDate endDate = calendar.DateFromComponents(endDateComponents);
				SFAppointment appointment = new SFAppointment();
				appointment.StartTime = startDate;
				appointment.EndTime = endDate;
				appointment.AllDay = true;
				components.Day = components.Day + 1;
				endDateComponents.Day = endDateComponents.Day + 1;
				appointment.Subject = (NSString)"Meeting";
				appCollection.Add(appointment);
			}
			return appCollection;
		}



		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
			// Release any cached data, images, etc that aren't in use.
		}
	}
	public class TableSource : UITableViewSource
	{
		
		string[] TableItems;
		string CellIdentifier = "TableCell";

		public TableSource(string[] items)
		{
			TableItems = items;
		}

		public override UITableViewCell GetCell(UITableView tableView, NSIndexPath indexPath)
		{
			UITableViewCell cell = tableView.DequeueReusableCell(CellIdentifier);
			string item = TableItems[indexPath.Row];

			//---- if there are no cells to reuse, create a new one
			if (cell == null)
			{ cell = new UITableViewCell(UITableViewCellStyle.Default, CellIdentifier); }

			cell.TextLabel.Text = item;

			return cell;
		}

		public override nint RowsInSection(UITableView tableview, nint section)
		{
			return TableItems.Length;
		}

		public override void RowSelected(UITableView tableView, NSIndexPath indexPath)
		{
			UIAlertView alert = new UIAlertView()
			{
				Title = "alert title",
				Message = "Event selected"
			};
			alert.AddButton("OK");
			alert.Show();
				  tableView.DeselectRow(indexPath, true);

		}
	}
	public class CalendarDelegate : SFCalendarDelegate
	{
		public string[] tempstr;
		public override UIView DidDrawInlineView(SFCalendar calendar, NSArray appointments)
		{
			UITableView tableView = new UITableView();
			//tableView.Delegate = new TableDelegate();
			 string[] tableItems = new string[appointments.Count];

			for (nuint i = 0; i < appointments.Count; i++)
			{
				SFAppointment appointment = appointments.GetItem<SFAppointment>(i);
				if (appointment != null)
				{
					
					UILabel lb = new UILabel();
					lb.Frame = new CGRect(0,0,70,40);
					lb.Text = appointment.Subject;
					lb.TextColor = UIColor.Black;
					tableItems[i]=appointment.Subject;
				}
			}
			tableView.Source = new TableSource(tableItems);
			tempstr = tableItems;
			return tableView;
		}
	}
	//public class TableDelegate : UITableViewDelegate 
	//{
	//	CalendarDelegate CalD = new CalendarDelegate();
	//	public override void RowHighlighted(UITableView tableView, NSIndexPath rowIndexPath)
	//	{
	//		UIAlertController okAlertController = UIAlertController.Create("Row Selected", CalD.tempstr[rowIndexPath.Row], UIAlertControllerStyle.Alert);
	//		okAlertController.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, null));
	//		tableView.DeselectRow(rowIndexPath, true);
	//	}
	//	public override void RowSelected(UITableView tableView, NSIndexPath indexPath)
	//	{
	//		UIAlertController okAlertController = UIAlertController.Create("Row Selected", CalD.tempstr[indexPath.Row], UIAlertControllerStyle.Alert);
	//		okAlertController.AddAction(UIAlertAction.Create("OK", UIAlertActionStyle.Default, null));
	//	  tableView.DeselectRow(indexPath, true);
	//	}
	//}
}
